<?php
// *** BlognPlus XML-RPC ***
//
// blogapi.php v1.0.1
// Copyright takayan
// LAST UPDATE 2010/12/10
//
//--------------------------------------------------------------------

if(!defined( 'BLOGAPIDIR' ))exit;
define("BLOGN_BLOGAPI_VERSION","1.0.0" );
$blogn_blogapi_agent = $_SERVER["HTTP_USER_AGENT"];
if (strpos($blogn_blogapi_agent,'wp-iphone' )!==FALSE) {
	die( 'unsupported agent' );
}

include_once("./conf.php" );
include_once("./common.php" );
include_once( BLOGAPIDIR . 'xmlrpc.inc.php' );
include_once( BLOGAPIDIR . 'xmlrpcs.inc.php' );
$xmlrpc_internalencoding = 'UTF-8';

if (!defined( 'BLOGN_FILEURL' )) {
	define( 'BLOGN_FILEURL', BLOGN_HOMELINK.'files/' );
}

//--------------------------------------------------------------------
// error code

define("BLOGN_BLOGAPI_UNKNOWN_ERROR",800);
define("BLOGN_BLOGAPI_BAD_CATEGORY_NAME",801);
define("BLOGN_BLOGAPI_CANNOT_POST_AS_PAGE",802);
define("BLOGN_BLOGAPI_CATEGORY_STRING_ERROR",803);
define("BLOGN_BLOGAPI_CLOSE_FILE_ERROR",804);
define("BLOGN_BLOGAPI_CREATE_FILE_ERROR",805);
define("BLOGN_BLOGAPI_DELETE_POST_ERROR",806);
define("BLOGN_BLOGAPI_EDIT_POST_ERROR",807);
define("BLOGN_BLOGAPI_LOAD_CATEGORY_ERROR",808);
define("BLOGN_BLOGAPI_LOAD_ENTRY_ERROR",809);
define("BLOGN_BLOGAPI_LOAD_INITDATA_ERROR",810);
define("BLOGN_BLOGAPI_LOAD_PROFILE_ERROR",811);
define("BLOGN_BLOGAPI_LOAD_TRACKBACK_ERROR",812);
define("BLOGN_BLOGAPI_LOAD_USERLIST_ERROR",813);
define("BLOGN_BLOGAPI_LOGIN_ERROR",814);
define("BLOGN_BLOGAPI_MEDIA_TYPE_ERROR",815);
define("BLOGN_BLOGAPI_NONASCII_NAME_ERROR",816);
define("BLOGN_BLOGAPI_NOT_ADMIN",817);
define("BLOGN_BLOGAPI_NOT_SUPPORT_PAGE",818);
define("BLOGN_BLOGAPI_NO_COMMENT_DELETE_PERMISSION",819);
define("BLOGN_BLOGAPI_NO_COMMENT_EDIT_PERMISSION",820);
define("BLOGN_BLOGAPI_NO_COMMENT_REPLY_PERMISSION",821);
define("BLOGN_BLOGAPI_NO_DELETE_PERMISSION",822);
define("BLOGN_BLOGAPI_NO_EDIT_PERMISSION",823);
define("BLOGN_BLOGAPI_NO_PERMISSION",824);
define("BLOGN_BLOGAPI_OPEN_FILE_ERROR",825);
define("BLOGN_BLOGAPI_OUT_OF_NUMBER",826);
define("BLOGN_BLOGAPI_PARAM_CLASS_ERROR",827);
define("BLOGN_BLOGAPI_POST_ERROR",828);
define("BLOGN_BLOGAPI_PROHIBIT_UPLOAD",829);
define("BLOGN_BLOGAPI_SEND_TRACKBACK_ERROR",830);
define("BLOGN_BLOGAPI_SET_CATEGORY_ERROR",831);
define("BLOGN_BLOGAPI_TOO_LARGRE",832);
define("BLOGN_BLOGAPI_TOO_MANY_CATEGORIES",833);
define("BLOGN_BLOGAPI_UNREGISTERED_NAME",834);
define("BLOGN_BLOGAPI_USERPROFILE_ERROR",835);
define("BLOGN_BLOGAPI_USER_DATA_LOAD_ERROR",836);
define("BLOGN_BLOGAPI_WRITE_FILE_ERROR",837);



$blogn_blogapi_error_message = array(
	BLOGN_BLOGAPI_UNKNOWN_ERROR                => "未定義のエラーが発生しました。",
	BLOGN_BLOGAPI_BAD_CATEGORY_NAME            => "カテゴリー名が異常です。",
	BLOGN_BLOGAPI_CANNOT_MODIFY_COMMENT        => "このクライアントからのコメントの修正はできません。",
	BLOGN_BLOGAPI_CATEGORY_STRING_ERROR        => "カテゴリーの文字列に誤りがあります。",
	BLOGN_BLOGAPI_CLOSE_FILE_ERROR             => "ファイルクローズエラーが起きました。アップロードを中止します。",
	BLOGN_BLOGAPI_CREATE_FILE_ERROR            => "ファイルを作成できません。アップロードを中止します。",
	BLOGN_BLOGAPI_DELETE_POST_ERROR            => "記事の削除に失敗しました。",
	BLOGN_BLOGAPI_EDIT_POST_ERROR              => "記事の変更に失敗しました。",
	BLOGN_BLOGAPI_LOAD_CATEGORY_ERROR          => "カテゴリー・データの読み込みに失敗しました。",
	BLOGN_BLOGAPI_LOAD_ENTRY_ERROR             => "記事の読み込みに失敗しました。記事が存在しない可能性があります。",
	BLOGN_BLOGAPI_LOAD_INITDATA_ERROR          => "初期設定データの読み込みに失敗しました。",
	BLOGN_BLOGAPI_LOAD_PROFILE_ERROR           => "プロフィール・データの読み込みに失敗しました。",
	BLOGN_BLOGAPI_LOAD_TRACKBACK_ERROR         => "トラックバックデータのロードに失敗しました。",
	BLOGN_BLOGAPI_LOAD_USERLIST_ERROR          => "ユーザー・リストの読み込みに失敗しました。",
	BLOGN_BLOGAPI_LOGIN_ERROR                  => "ログインに失敗しました。",
	BLOGN_BLOGAPI_MEDIA_TYPE_ERROR             => "許可されていないファイルタイプです。アップロードを中止します。",
	BLOGN_BLOGAPI_NONASCII_NAME_ERROR          => "半角英数以外の文字が使われています。",
	BLOGN_BLOGAPI_NOT_ADMIN                    => "管理者権限がないので、この操作はできません。",
	BLOGN_BLOGAPI_NOT_SUPPORT_PAGE             => "ぶろぐん＋にはページコンテンツはありません。",
	BLOGN_BLOGAPI_NO_COMMENT_DELETE_PERMISSION => "このコメントを削除する権限はありません。",
	BLOGN_BLOGAPI_NO_COMMENT_EDIT_PERMISSION   => "このコメントの状態を変更する権限はありません。",
	BLOGN_BLOGAPI_NO_COMMENT_REPLY_PERMISSION  => "このクライアントからこの記事にコメントする権限はありません。",
	BLOGN_BLOGAPI_NO_DELETE_PERMISSION         => "この記事を削除する権限はありません。",
	BLOGN_BLOGAPI_NO_EDIT_PERMISSION           => "この記事を編集する権限はありません。",
	BLOGN_BLOGAPI_NO_PERMISSION                => "この記事に対する権限はありません。",
	BLOGN_BLOGAPI_OPEN_FILE_ERROR              => "ファイルをオープンできません。アップロードを中止します。",
	BLOGN_BLOGAPI_OUT_OF_NUMBER                => "数値が範囲を超えています。",
	BLOGN_BLOGAPI_PARAM_CLASS_ERROR            => "引数のクラスに問題があります。",
	BLOGN_BLOGAPI_POST_ERROR                   => "投稿に失敗しました。",
	BLOGN_BLOGAPI_PROHIBIT_UPLOAD              => "アップロードが禁止されています。",
	BLOGN_BLOGAPI_SEND_TRACKBACK_ERROR         => "トラックバックの送信に失敗しました。",
	BLOGN_BLOGAPI_SET_CATEGORY_ERROR           => "カテゴリー・データの設定に失敗しました。",
	BLOGN_BLOGAPI_TOO_LARGRE                   => "ファイルが指定されたサイズよりも大きいです。アップロードを中止します。",
	BLOGN_BLOGAPI_TOO_MANY_CATEGORIES          => "カテゴリーの種類が多すぎます。削除してください。",
	BLOGN_BLOGAPI_UNREGISTERED_NAME            => "未登録のユーザーです。",
	BLOGN_BLOGAPI_USERPROFILE_ERROR            => "ユーザープロフィールのエラーです。",
	BLOGN_BLOGAPI_USER_DATA_LOAD_ERROR         => "ユーザーデータのロードに失敗しました。",
	BLOGN_BLOGAPI_WRITE_FILE_ERROR             => "ファイル書き込みエラーが起きました。アップロードを中止します。",
);


//--------------------------------------------------------------------


function blogn_blogapi_fault_result($err_code) {
	global $blogn_blogapi_error_message;
	if ( array_key_exists($err_code,$blogn_blogapi_error_message) ) {
		return new xmlrpcresp( 0, $err_code, ($blogn_blogapi_error_message[$err_code]) );
	} else {
		return new xmlrpcresp( 0, $err_code, ($blogn_blogapi_error_message[BLOGN_BLOGAPI_UNKNOWN_ERROR]) );
	}
}


function blogn_blogapi_false_result() {
	return new xmlrpcresp( new xmlrpcval( FALSE, 'boolean' ));
}


function blogn_blogapi_true_result() {
	return new xmlrpcresp( new xmlrpcval( TRUE, 'boolean' ));
}


function blogn_blogapi_blogndate_iso8601($date) {
	return date("Ymd\TH:i:s",
		mktime(substr($date,8,2), substr($date,10,2), substr($date,12,2),
					substr($date,4,2), substr($date,6,2), substr($date,0,4)));
}


function blogn_blogapi_iso8601_blogndate($date) {
	if ( preg_match( "/Z$/", $date ) ) {
		$initlist = blogn_blogapi_get_init_data();
		$timezone = $initlist["timezone"];
		return date("YmdHis",
			mktime( substr($date,9,2)+$timezone, substr($date,12,2), substr($date,15,2),
				substr($date,4,2), substr($date,6,2), substr($date,0,4) ) );
	} else {
		return preg_replace( "/^([^T]*)T([^:]*):([^:]*):([^:]*)$/", "$1$2$3$4", $date );
	}
}


function blogn_blogapi_iso8601_time($date) {
	if ( preg_match( "/Z$/", $date ) ) {
		$initlist = blogn_blogapi_get_init_data();
		$timezone = $initlist["timezone"];
	} else {
		$timezone = 0;
	}

	return mktime( substr($date,9,2)+$timezone, substr($date,12,2), substr($date,15,2),
			substr($date,4,2), substr($date,6,2), substr($date,0,4) );
}


function blogn_blogapi_get_param_as_scalar( $params, $number ) {
	if ( $params instanceof xmlrpcmsg ) {
		$val = $params -> getParam( $number );
		return $val -> scalarval();
	} else {
		throw new Exception(BLOGN_BLOGAPI_PARAM_CLASS_ERROR);
	}
}


function blogn_blogapi_get_param( $params, $number ) {
	if ( $params instanceof xmlrpcmsg ) {
		$val = $params -> getParam( $number );
		return $val;
	} else {
		throw new Exception(BLOGN_BLOGAPI_PARAM_CLASS_ERROR);
	}
}


function blogn_blogapi_comment_root_id( $comment_id ) {

	$comments = blogn_mod_db_comment_load_for_new(1,0,0);

	if ($comments[0]) {
		foreach ( $comments[1] as $val ) {
			if ( $val['id'] ==  $comment_id ) {
				return $val['entry_id'];
			}
		}
	}

	return '';
}


function blogn_blogapi_user_check( $username, $password ) {

	$result = blogn_mod_db_user_check( $username, $password );

	if (!$result[0]) {
		throw new Exception(BLOGN_BLOGAPI_LOGIN_ERROR);
	}
}


function blogn_blogapi_check_permission( $username, $post_id )
{
	$user_id = blogn_blogapi_get_user_id( $username );

	$log = blogn_mod_db_log_load_for_entory($username, $post_id);
	if (!$log[0]) {
		throw new Exception(BLOGN_BLOGAPI_LOAD_ENTRY_ERROR);
	}

	$user_profile = blogn_blogapi_get_user_profile( $user_id );

	if ( ( $log[1]['user_id'] != $user_id ) && !$user_profile['admin'] ) {
		throw new Exception(BLOGN_BLOGAPI_NO_PERMISSION);
	}
}


function blogn_blogapi_get_user_list() {
	$result = blogn_mod_db_user_load();
	if ( !$result ) {
		throw new Exception(BLOGN_BLOGAPI_LOAD_USERLIST_ERROR);
	}
	return $result;
}


function blogn_blogapi_get_user_id( $username ) {
	$result = blogn_blogapi_get_user_list();
	foreach ( $result as $key => $val ) {
		if ( $val["id"] == $username ) {
			return $key;
		}
	}
	throw new Exception(BLOGN_BLOGAPI_UNREGISTERED_NAME);
}


function blogn_blogapi_get_user_nickname( $username ) {
	$result = blogn_blogapi_get_user_list();
	foreach ( $result as $key => $val ) {
		if ( $val["id"] == $username ) {
			$user_key = $key;
			break;
		}
	}
	return $result[$user_key]['name'];
}


function blogn_blogapi_get_secret( $username, $post_id ) {
	$log = blogn_mod_db_log_load_for_entory( $username, $post_id );
	if (!$log[0]) {
		throw new Exception(BLOGN_BLOGAPI_LOAD_ENTRY_ERROR);
	}
	return $log[1]['secret'];
}


function blogn_blogapi_get_blogndate( $date ) {
	if ( $date ) {
		$date = blogn_blogapi_iso8601_blogndate($date);
	}
	return $date ? $date : date("YmdHis");
}


function blogn_blogapi_get_struct_member( $struct, $member_name ) {
	$member = $struct -> structmem( $member_name );
	return ($member) ? ($member->scalarval()) : '';
}


function blogn_blogapi_send_trackback( $ping_url, $client_url, $title, $excerpt ) {
	$excerpt = str_replace( "<br>",   "\n", $excerpt); 
	$excerpt = str_replace( "<br />", "\n", $excerpt);
	$excerpt = blogn_CleanHtml($excerpt);
	if (strlen($excerpt) > 255) {
		$excerpt = blogn_mbtrim($excerpt,255);
	}

	$post  = "title="      .urlencode($title        );
	$post .= "&url="       .urlencode($client_url   );
	$post .= "&blog_name=" .urlencode(BLOGN_SITENAME);
	$post .= "&excerpt="   .urlencode($excerpt      );
	$post .= "&charset=utf-8";

	$ping = parse_url($ping_url);

	$req  = "POST "  . $ping_url . " HTTP/1.1\r\n";
	$req .= "Host: " . $ping['host']  . "\r\n";
	$req .= "User-Agent: PHP/" . phpversion() . "\r\n";
	$req .= "Content-Type: application/x-www-form-urlencoded\r\n";
	$req .= "Content-Length: " . strlen($post) . "\r\n";
	$req .= "\r\n";
	$req .= $post."\r\n";

	$fp = @fsockopen( $ping["host"], $ping["port"]?$ping["port"]:80 );
	if (!$fp) {
		throw new Exception(BLOGN_BLOGAPI_SEND_TRACKBACK_ERROR);
	}
	fputs($fp, $req);
	$res = "";
	while (!feof($fp)) {
		$res .= fgets($fp);
	}
	fclose($fp);

	if (strpos($res,"<error>0</error>")===FALSE) {
		throw new Exception(BLOGN_BLOGAPI_SEND_TRACKBACK_ERROR);
	}

	return TRUE;
}


function blogn_blogapi_new_post($user_id,$date,$reserve,$secret,$comment_ok,$trackback_ok,$category,$title,$mes,$more,$br_change) {

	$result = blogn_mod_db_log_add($user_id,$date,$reserve,$secret,$comment_ok,$trackback_ok,$category,$title,$mes,$more,$br_change);

	if (!$result[0]) {
		throw new Exception(BLOGN_BLOGAPI_POST_ERROR);
	}

	return $result[2];
}


function blogn_blogapi_get_log($username, $postid) {

	$log = blogn_mod_db_log_load_for_entory($username, $postid);
	if (!$log[0]) {
		throw new Exception(BLOGN_BLOGAPI_LOAD_ENTRY_ERROR);
	}

	return $log[1];
}


function blogn_blogapi_edit_log($postid,$date,$reserve,$secret,$comment_ok,$trackback_ok,$category,$title,$mes,$more,$br_change) {

	$result = blogn_mod_db_log_change($postid,$date,$reserve,$secret,$comment_ok,$trackback_ok,$category,$title,$mes,$more,$br_change);

	if (!$result[0]) {
		throw new Exception(BLOGN_BLOGAPI_EDIT_POST_ERROR);
	}
}


function blogn_bloapi_create_filename( $name, $ext, $overwrite=FALSE ) {

	if (!$name) {
		throw new Exception(BLOGN_BLOGAPI_CREATE_FILE_ERROR);
	}

	$original = basename( $name, ".$ext" );
	$file     = BLOGN_FILEDIR . $name;

	if ( $overweite || !file_exists( $file ) ) {
		return $file;
	}

	for ( $i = 0; $i < 10; $i++ ) {
		$name = $original . '_' . mt_rand() . ".$ext";
		$file = BLOGN_FILEDIR . $original . '_' . mt_rand() . ".$ext";
		if ( !file_exists($file) ) {
			return $file;
		}
	}

	throw new Exception(BLOGN_BLOGAPI_CREATE_FILE_ERROR);
}


function blogn_blogapi_upload( $username, $data, $overwrite )
{
	$name = blogn_blogapi_get_struct_member( $data, 'name' );
	$bits = blogn_blogapi_get_struct_member( $data, 'bits' );

	$name = basename($name);
	if (preg_match("/[^a-zA-Z0-9_\-\.\(\) ]/", $name)) {
		throw new Exception(BLOGN_BLOGAPI_NONASCII_NAME_ERROR);
	}

	$info = pathinfo($name);
	$ext  = strtolower($info['extension']);
	$ext_list = explode( ',', strtolower(BLOGN_PERMIT_FILE_TYPE) );

	if (!$ext_list) {
		throw new Exception(BLOGN_BLOGAPI_PROHIBIT_UPLOAD);
	}

	if (!in_array( $ext, $ext_list )) {
		throw new Exception(BLOGN_BLOGAPI_MEDIA_TYPE_ERROR);
	}

	if ( strlen($bits) > BLOGN_MAX_FILESIZE * 1024 ) {
		throw new Exception(BLOGN_BLOGAPI_TOO_LARGRE);
	}

	$file = blogn_bloapi_create_filename( $name, $ext, $overwrite );

	$fp = fopen( $file, 'wb' );
	if (!$fp) {
		throw new Exception(BLOGN_BLOGAPI_OPEN_FILE_ERROR);
	}

	$result= fwrite( $fp, $bits );
	if (!$result) {
		fclose($fp);
		throw new Exception(BLOGN_BLOGAPI_WRITE_FILE_ERROR);
	}

	$result = fclose($fp);
	if (!$result) {
		throw new Exception(BLOGN_BLOGAPI_CLOSE_FILE_ERROR);
	}

	blogn_mod_db_file_add( blogn_blogapi_get_user_id( $username ), $name, '' );

	return $name;
}


function blogn_blogapi_delete_log($postid) {
	$result = blogn_mod_db_log_delete($postid);
	if (!$result[0]) {
		throw new Exception(BLOGN_BLOGAPI_DELETE_POST_ERROR);
	}
}


function blogn_blogapi_change_title( $postid, $category, $title ) {

	$result = blogn_mod_db_log_title_change( $postid, $category, $title );

	if (!$result[0]) {
		throw new Exception(BLOGN_BLOGAPI_SET_CATEGORY_ERROR);
	}
}


function blogn_blogapi_make_trackback_list($data) {
	$array = array();
	switch( $data -> kindOf() ) {
	case 'scalar':
		$array = explode( ' ',  $data -> scalarval() );
		break;

	case 'array':
		for ( $i = 0; $i < $data -> arraysize(); $i++ ) {
			$array [] = $data -> arraymem($i) -> scalarval();
		}
		break;
	}

	return ( count($array) == 1 && $array[0] == '(コンマ区切り)' ) ? array() : $array;
}


function blogn_blogapi_category_name_to_id($name) {

	list( $c1, $c2 ) = blogn_blogapi_category_name_to_list( $name );

	list( $c1_id_a, $c2_id_a ) = blogn_blogapi_category_names_to_id_array( $c1, $c2 );

	if ($c1_id_a) {
		$c1_id = $c1_id_a['id'];
	} else {
		$c1_id = blogn_blogapi_make_new_category1($c1);
	}

	if ($c2_id_a) {
		$c2_id = $c2_id_a['id'];
	} else {
		if ($c2) {
			$c2_id = blogn_blogapi_make_new_category2($c1_id,$c2);
		} else {
			$c2_id = '';
		}
	}

	$category_id = "$c1_id|$c2_id";

	return $category_id;
}


function blogn_blogapi_category_array_to_id( $categories ) {
	$category_id = '';
	if ( $categories ) {
		$category = "";
		if ($categories) {
			$size = $categories -> arraysize();
			for ( $i = 0; $i < $size; $i++ ) {
				$data = $categories -> arraymem($i);
				if ( $data ) {
					$category = $data -> scalarval();
					break;
				}
			}
		}
		if ($category) {
			$category_id = blogn_blogapi_category_name_to_id( $category );
		}
	}
	return $category_id;
}


function blogn_blogapi_category1_id_to_name($id) {
	$result = blogn_blogapi_get_category1_list();
	return ($result)?$result[$id]['name']:'';
}


function blogn_blogapi_category2_id_to_name($id) {
	$result = blogn_blogapi_get_category2_list();
	return $result[$id]['name'];
}


function blogn_blogapi_get_category1_list() {

	$result = blogn_mod_db_category1_load();
	if (!$result) {
		throw new Exception(BLOGN_BLOGAPI_LOAD_CATEGORY_ERROR);
	}
	return ( $result[0] ) ? $result[1] : array();
}


function blogn_blogapi_get_category2_list() {

	$result = blogn_mod_db_category2_load();
	if (!$result) {
		throw new Exception(BLOGN_BLOGAPI_LOAD_CATEGORY_ERROR);
	}
	return ( $result[0] ) ? $result[1] : array();
}


function blogn_blogapi_make_new_category1($c1) {

	$result = blogn_mod_db_category1_add($c1);
	if (!$result[0]) {
		throw new Exception(BLOGN_BLOGAPI_CREATE_FILE_ERROR);
	}
	return $result[2];
}


function blogn_blogapi_make_new_category2($c1_id,$c2) {

	$result = blogn_mod_db_category2_add($c1_id,$c2);
	if (!$result[0]) {
		throw new Exception(BLOGN_BLOGAPI_CREATE_FILE_ERROR);
	}
	return $result[2];
}


function blogn_blogapi_category_name_to_list( $name ) {
	if (!$name) {
		return array( '', '' );
	}

	$list = explode( '::', $name );

	if ( count($list) > 2 ) {
		throw new Exception(BLOGN_BLOGAPI_CATEGORY_STRING_ERROR);
	}

	$c1 = $list[0];

	if( !$c1 ) {
		throw new Exception(BLOGN_BLOGAPI_CATEGORY_STRING_ERROR);
	}

	$c2 = ( count($list) == 2 ) ? $list[1] : '';

	return array( $c1, $c2 );
}


function blogn_blogapi_category1_name_to_id_array( $c1 ) {

	$c1_list = blogn_blogapi_get_category1_list();

	foreach ( $c1_list as $id => $val ) {
		if ( $c1_list[$id]['name'] == $c1 ) {
			return array( 'id' => $id );
		}
	}
	return false;
}


function blogn_blogapi_category2_name_to_id_array( $c1_id, $c2 ) {

	$c2_list = blogn_blogapi_get_category2_list();

	foreach ( $c2_list as $id => $val ) {
		if ( $c2_list[$id]['name'] == $c2 && $c2_list[$id]['id'] == $c1_id ) {
			return array( 'id' => $id );
		}
	}
	return false;
}


function blogn_blogapi_category_names_to_id_array( $c1, $c2 ) {

	$c1_id = blogn_blogapi_category1_name_to_id_array( $c1 );
	$c2_id = ($c1_id) ? blogn_blogapi_category2_name_to_id_array( $c1_id['id'], $c2 ) : false;

	return array( $c1_id, $c2_id );
}


function blogn_blogapi_get_category_list() {

	$c1 = blogn_blogapi_get_category1_list();
	$c2 = blogn_blogapi_get_category2_list();

	$c2_list = array();
	foreach ( $c2 as $key => $value ) {
		if ( $value['id'] != '' ) {
			$c2_list [$value['id']] [] = array( 'name' => $value['name'], 'id' => $key );
		}
	}

	$c_list = array();
	if ($c1) {
		foreach ( $c1 as $c1_k => $c1_v ) {
			$c1_name = $c1_v['name'];
			$c_list [] = array(
				 'name'    => $c1_name
				,'spec'    => "$c1_k-"
				,'blognid' => "$c1_k|"
				,'id'      => blogn_blogapi_category_id_to_number("$c1_k|")
			);
			if ($c2_list[$c1_k]) {
				foreach( $c2_list[$c1_k] as $c2_v ) {
					$c2_name = $c2_v['name'];
					$c2_k    = $c2_v['id'];
					$c_list [] = array(
						 'name'    => $c1_name . '::' . $c2_name
						,'spec'    => "$c1_k-$c2_k"
						,'blognid' => "$c1_k|$c2_k"
						,'id'      => blogn_blogapi_category_id_to_number("$c1_k|$c2_k")
					);
				}
			}
		}
	}
	return $c_list;
}


function blogn_blogapi_category_number_to_id($category_number) {
	$c1 = ( $category_number >> 16 ) & bindec('1111111111111111');
	$c2 = $category_number & bindec('1111111111111111');
	return "$c1|$c2";
}


function blogn_blogapi_category_id_to_number( $category_id ) {
	if ($category_id=='') {
		$category_id = '|';
	}
	$list = explode( '|', $category_id );
	if ( count($list) == 2 ) {
		$c1 = intval( $list[0] );
		$c2 = intval( $list[1] );
		if ( $c1 < 0 || $c1 >= 65536 ||  $c2 < 0 || $c2 >= 65536 ) {
			throw new Exception(BLOGN_BLOGAPI_TOO_MANY_CATEGORIES);
		}
		$id = ( $c1 << 16 ) | $c2;
	} else {
		$id = 0;
	}
	return $id;
}


function blogn_blogapi_category_id_to_name( $category_id ) {
	if ($category_id=='') {
		$category_id = '|';
	}
	$list = explode( '|', $category_id );
	if ( count($list) != 2  ) {
		throw new Exception(BLOGN_BLOGAPI_CATEGORY_STRING_ERROR);
	}
	$c1_id = $list[0];
	$c2_id = $list[1];

	$category = blogn_blogapi_category1_id_to_name( $c1_id );
	if ($c2_id) {
		$category .= '::' . blogn_blogapi_category2_id_to_name( $c2_id );
	}
	return $category;
}


function blogn_blogapi_get_init_data() {
	$result = blogn_mod_db_init_load();
	if (!$result) {
		throw new Exception(BLOGN_BLOGAPI_LOAD_INITDATA_ERROR);
	}
	return $result;
}


function blogn_blogapi_get_user_profile( $userid ) {

	$result = blogn_mod_db_user_profile_load( $userid );
	if (!$result) {
		throw new Exception(BLOGN_BLOGAPI_LOAD_PROFILE_ERROR);
	}
	return $result;
}


function blogn_blogapi_user_category_number_to_id( $category_number, $userid ) {

	if ( $category_number == 0 ) {
		$userdata = blogn_blogapi_get_user_profile( $userid );
		return $userdata['init_category'];
	}
	return blogn_blogapi_category_number_to_id( $category_number );
}



function blogn_blogapi_user_category_id_to_name( $category_id, $userid ) {

	if ( $category_id == '' || $category_id == '|' ) {
		$userdata = blogn_blogapi_get_user_profile( $userid );
		$category_id = $userdata['init_category'];
		if ( $category_id == '' || $category_id == '|' ) {
			return '';
		}
	}
	return blogn_blogapi_category_id_to_name( $category_id );
}


//--------------------------------------------------------------------
// API
//--------------------------------------------------------------------


function blogger_newPost($params) {
	try {
//		$blogid   = blogn_blogapi_get_param_as_scalar($params,1);
		$username = blogn_blogapi_get_param_as_scalar($params,2);
		$password = blogn_blogapi_get_param_as_scalar($params,3);

		blogn_blogapi_user_check( $username, $password );

		$publish  = blogn_blogapi_get_param_as_scalar($params,5);
		$secret = $publish ? FALSE : TRUE;

		$user_id  = blogn_blogapi_get_user_id( $username );
		$user_profile = blogn_blogapi_get_user_profile( $user_id );

		$content = htmlspecialchars_decode( blogn_blogapi_get_param_as_scalar($params,4) );

		preg_match( "/<title>([^<]+)<\/title>/", $content, $matches );
		$title = $matches[1];

		preg_match( "/<category>([^<]*)<\/category>/", $content, $matches );
		$category = $matches[1];
		$category_id = blogn_blogapi_category_number_to_id($category);

		$content = preg_replace( "/<title>([^<]*)<\/title>\n/", "", $content );
		$content = preg_replace( "/<category>([^<]*)<\/category>\n/", "", $content );

		$date = date("YmdHis");
		$reserve = 0;

		$comment_ok   = $user_profile["init_comment_ok"]   ? TRUE : FALSE;
		$trackback_ok = $user_profile["init_trackback_ok"] ? TRUE : FALSE;
		$category     = $category_id;
		$title        = blogn_mod_db_rn2br( blogn_permit_html_tag_restore( $title   ));
		$mes          = blogn_mod_db_rn2br( blogn_permit_html_tag_restore( $content ));
		$more         = '';
		$br_change    = $user_profile["br_change"] ? TRUE : FALSE;

		$logid = blogn_blogapi_new_post($user_id,$date,$reserve,$secret,$comment_ok,$trackback_ok,$category,$title,$mes,$more,$br_change);

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}

	return new xmlrpcresp( new xmlrpcval( $logid, 'string' ) );
}


function metaWeblog_newPost($params) {
	try {
		$username = blogn_blogapi_get_param_as_scalar($params,1);
		$password = blogn_blogapi_get_param_as_scalar($params,2);
		$content  = blogn_blogapi_get_param($params,3);

		blogn_blogapi_user_check( $username, $password );

		$secret = FALSE;
		global $blogn_blogapi_agent;
		if (strpos($blogn_blogapi_agent,'wp-iphone' )===FALSE) {
			$publish = blogn_blogapi_get_param_as_scalar($params,4);
			$secret  = $publish ? FALSE : TRUE;
			$secret = !$publish;
		}
		$user_id = blogn_blogapi_get_user_id( $username );

		$user_profile = blogn_blogapi_get_user_profile($user_id);

		$category_id = blogn_blogapi_category_array_to_id( $content->structmem('categories') );
		if (!$category_id) {
			$category_id = $user_profile['init_category'];
		}

		if ($content->structmem( 'post_status' )) {
			switch ($content->structmem( 'post_status' )) {
			case 'draft'  :
			case 'pending':
			case 'private':
				$secret = TRUE;
				break;
			case 'publish':
				$secret = FALSE;
				break;
			default:
				$secret = FALSE;
				break;
			}
		}

		$value = $content->structmem("date_created_gmt");
		if ($value) {
			$value   = $value -> scalarval();
			$value   = $value . 'Z';
			$date    = blogn_blogapi_iso8601_blogndate($value);
			$time    = blogn_blogapi_iso8601_time($value);
			$reserve = ($time>time())?1:0;
		} else {
			$value = $content->structmem("dateCreated");
			if ($value) {
				$value   = $value -> scalarval();
				$date    = blogn_blogapi_iso8601_blogndate($value);
				$time    = blogn_blogapi_iso8601_time($value);
				$reserve = ($time>time())?1:0;
			}
		}
		if (!$value) {
			$date    = date("YmdHis");
			$reserve = 0;
		}

		$comment_ok   = ( $value = $content->structmem("mt_allow_comments") ) ? $value -> scalarval() : $user_profile["init_comment_ok"];
		$comment_ok   = $comment_ok ? TRUE : FALSE;
		$trackback_ok = ( $value = $content->structmem("mt_allow_pings") ) ? $value -> scalarval() : $user_profile["init_trackback_ok"];
		$trackback_ok = $trackback_ok ? TRUE : FALSE;
		$category     = $category_id;
		$title        = ( $value = $content->structmem("title") ) ? blogn_mod_db_rn2br( blogn_permit_html_tag_restore( $value -> scalarval() )) : '(タイトル無し)';
		$mes          = ( $value = $content->structmem("description")  ) ? blogn_mod_db_rn2br( blogn_permit_html_tag_restore( $value -> scalarval() )) : '';
		$more         = ( $value = $content->structmem("mt_text_more") ) ? blogn_mod_db_rn2br( blogn_permit_html_tag_restore( $value -> scalarval() )) : '';
		$br_change    = ( $value = $content->structmem("mt_convert_breaks") ) ? $value->scalarval() : $user_profile["br_change"];
		$br_change    = $br_change ? TRUE : FALSE;

		$logid = blogn_blogapi_new_post($user_id,$date,$reserve,$secret,$comment_ok,$trackback_ok,$category,$title,$mes,$more,$br_change);

		if ( $content -> structmem("mt_tb_ping_urls") ) {
			$array = blogn_blogapi_make_trackback_list( $content -> structmem("mt_tb_ping_urls") );
			foreach ( $array as $url ) {
				blogn_blogapi_send_trackback( htmlentities($url), BLOGN_HOMELINK."?e=".$logid, $title, $mes );
			}
		}
	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}

	return new xmlrpcresp( new xmlrpcval( "$logid", 'string' ) );
}


function metaWeblog_editPost($params) {
	try {
		$postid   = blogn_blogapi_get_param_as_scalar($params,0);
		$username = blogn_blogapi_get_param_as_scalar($params,1);
		$password = blogn_blogapi_get_param_as_scalar($params,2);
		$content  = blogn_blogapi_get_param($params,3);

		blogn_blogapi_user_check( $username, $password );
		blogn_blogapi_check_permission( $username, $postid );

		$user_profile = blogn_blogapi_get_user_profile( blogn_blogapi_get_user_id( $username ) );

		$log = blogn_blogapi_get_log( $username, $postid );

		$publish = blogn_blogapi_get_param_as_scalar($params,4);
		$secret  = $publish ? FALSE : TRUE;
		$secret = !$publish;

		$category_id = blogn_blogapi_category_array_to_id( $content->structmem('categories') );
		if (!$category_id) {
			$category_id = $log['category'];
		}

		if ($content->structmem( 'post_status' )) {

			$post_status = blogn_blogapi_get_struct_member( $content, 'post_status' );
			switch ($post_status) {
			case 'draft':
			case 'pending':
			case 'private':
				$secret = TRUE;
				break;
			case 'publish':
				$secret = FALSE;
				break;
			default:
				$secret = FALSE;
				break;
			}
		}

		$value = $content->structmem("dateCreated");
		if ( $value ) {
			$value = $value -> scalarval();
			$date  = blogn_blogapi_iso8601_blogndate($value);

			$time = blogn_blogapi_iso8601_time($value);
			$reserve = ($time>time())?1:0;
		} else {
			$date    = $log['date'];
			$reserve = $log['reserve'];
		}

		$comment_ok   = ( $value = $content->structmem("mt_allow_comments") ) ? $value -> scalarval() : $user_profile["init_comment_ok" ];
		$comment_ok   = $comment_ok ? TRUE : FALSE;
		$trackback_ok = ( $value = $content->structmem("mt_allow_pings") ) ? $value -> scalarval() : $user_profile["init_trackback_ok"];
		$trackback_ok = $trackback_ok ? TRUE : FALSE;
		$category     = $category_id;
		$title        = ( $value = $content->structmem("title") ) ? blogn_mod_db_rn2br( blogn_permit_html_tag_restore( $value -> scalarval() )) : '(タイトル無し)';
		$mes          = ( $value = $content->structmem("description") ) ? blogn_mod_db_rn2br( blogn_permit_html_tag_restore( $value -> scalarval() )) : '';
		$more         = ( $value = $content->structmem("mt_text_more") ) ? blogn_mod_db_rn2br( blogn_permit_html_tag_restore( $value -> scalarval() )) : '';
		$br_change    = ( $value = $content->structmem("mt_convert_breaks") ) ? $value->scalarval() : $user_profile["br_change"];
		$br_change    = $br_change ? TRUE : FALSE;

		blogn_blogapi_edit_log($postid,$date,$reserve,$secret,$comment_ok,$trackback_ok,$category,$title,$mes,$more,$br_change);

		if ( $content -> structmem("mt_tb_ping_urls") ) {
			$array = blogn_blogapi_make_trackback_list( $content -> structmem("mt_tb_ping_urls") );
			foreach ( $array as $url ) {
				blogn_blogapi_send_trackback( htmlentities($url), BLOGN_HOMELINK."?e=".$logid, $title, $mes );
			}
		}

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}

	return blogn_blogapi_true_result();
}


function metaWeblog_getPost($params) {
	try {
		$username = blogn_blogapi_get_param_as_scalar($params,1);
		$password = blogn_blogapi_get_param_as_scalar($params,2);

		blogn_blogapi_user_check( $username, $password );

		$postid = blogn_blogapi_get_param_as_scalar($params,0);
		global $blogn_blogapi_agent;
		if (strpos($blogn_blogapi_agent,'wp-iphone' )!==FALSE) {
			$postid = str_replace( BLOGN_HOMELINK . '-', '', $postid );
			$postid = intval($postid);
		}

		$log = blogn_blogapi_get_log( $username, $postid );

		try {
			blogn_blogapi_check_permission( $username, $postid );
		} catch (Exception $e) {
			throw new Exception(BLOGN_BLOGAPI_NO_EDIT_PERMISSION);
		}

		$keywords = "";

		$userid            = blogn_blogapi_get_user_id( $username );
		$dateCreated       = blogn_blogapi_blogndate_iso8601( $log['date'] );
		$description       = $log['mes'];
		$title             = htmlspecialchars( $log['title'] );
		$link              = BLOGN_HOMELINK . '?e=' . $log['id'];
		$permaLink         = $link;
		$mt_excerpt        = '';
		$mt_text_more      = $log['more'];
		$mt_allow_comments = $log['comment_ok'  ] ? TRUE : FALSE;
		$mt_allow_pings    = $log['trackback_ok'] ? TRUE : FALSE;
		$mt_convert_breaks = $log['br_change'   ] ? TRUE : FALSE;
		$mt_keywords       = $keywords;
		$post_status       = $log['secret'] ? 'private' : 'publish';

		$category = blogn_blogapi_user_category_id_to_name( $log['category'], $userid );

		$categories = array( new xmlrpcval( $category, 'string' ) );

		$struct = array(
			'userid'             => new xmlrpcval( $userid,            'string' )
			,'dateCreated'       => new xmlrpcval( $dateCreated,       'dateTime.iso8601' )
			,'postid'            => new xmlrpcval( $postid,            'string' )
			,'description'       => new xmlrpcval( $description,       'string' )
			,'title'             => new xmlrpcval( $title,             'string' )
			,'link'              => new xmlrpcval( $link,              'string' )
			,'permaLink'         => new xmlrpcval( $permaLink,         'string' )
			,'mt_excerpt'        => new xmlrpcval( $mt_excerpt,        'string' )
			,'mt_text_more'      => new xmlrpcval( $mt_text_more,      'string' )
			,'mt_allow_comments' => new xmlrpcval( $mt_allow_comments, 'string' )
			,'mt_allow_pings'    => new xmlrpcval( $mt_allow_pings,    'string' )
			,'mt_convert_breaks' => new xmlrpcval( $mt_convert_breaks, 'string' )
			,'mt_keywords'       => new xmlrpcval( $mt_keywords,       'string' )
			,'post_status'       => new xmlrpcval( $post_status,       'string' )
			,'categories'        => new xmlrpcval( $categories,        'array'  )
			,'publish'           => new xmlrpcval( ($log['secret']?0:1),  'boolean' )
		);

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}

	return new xmlrpcresp( new xmlrpcval( $struct, 'struct' ) );
}


function metaWeblog_getRecentPosts($params) {
	try {
	//	$blogid = blogn_blogapi_get_param_as_scalar($params,0);
		$username = blogn_blogapi_get_param_as_scalar($params,1);
		$password = blogn_blogapi_get_param_as_scalar($params,2);

		blogn_blogapi_user_check( $username, $password );

		$numberOfPosts = blogn_blogapi_get_param_as_scalar($params,3);
		if ( $numberOfPosts <= 0 ) {
			throw new Exception(BLOGN_BLOGAPI_OUT_OF_NUMBER);
		}

		$user_id = blogn_blogapi_get_user_id( $username );
		$loglist = blogn_mod_db_log_load_for_list( $user_id, 0, $numberOfPosts );
		if (!$loglist[0]) {
			return new xmlrpcresp( new xmlrpcval( array(), 'array' ) );
		}

		$array = array();
		foreach ( $loglist[1] as $val ) {

			$description = $val['mes'];
	//		$description = htmlspecialchars($description);

			$mt_text_more = $val['more'];
	//		$mt_text_more = htmlspecialchars($mt_text_more);

			$post_status  = $val['secret'] ? 'private' : 'publish';

			$keywords = '';

			$struct = array(
				 'dateCreated'       => new xmlrpcval( blogn_blogapi_blogndate_iso8601($val['date']), 'dateTime.iso8601' )
				,'userid'            => new xmlrpcval( $username,                       'string' )
				,'postid'            => new xmlrpcval( $val['id'],                      'string' )
				,'description'       => new xmlrpcval( $description,                    'string' )
				,'title'             => new xmlrpcval( htmlspecialchars($val['title']), 'string' )
				,'link'              => new xmlrpcval( BLOGN_HOMELINK.'?e='.$val["id"], 'string' )
				,'permaLink'         => new xmlrpcval( BLOGN_HOMELINK.'?e='.$val["id"], 'string' )
				,'mt_excerpt'        => new xmlrpcval( '',                              'string' )
				,'mt_text_more'      => new xmlrpcval( $mt_text_more,                   'string' )
				,'mt_allow_comments' => new xmlrpcval( $val['comment_ok']?TRUE:FALSE,   'int'    )
				,'mt_allow_pings'    => new xmlrpcval( $val['trackback_ok']?TRUE:FALSE, 'string' )
				,'mt_convert_breaks' => new xmlrpcval( $val['br_change']?TRUE:FALSE,    'string' )
				,'mt_keywords'       => new xmlrpcval( $keywords,                       'string' )
				,'post_status'       => new xmlrpcval( $post_status,                    'string' )
			);
			$array[] = new xmlrpcval( $struct, 'struct' );
		}

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}

	return new xmlrpcresp( new xmlrpcval( $array, 'array' ));
}


function blogger_getRecentPosts($params) {
	try {
	//  $appkey   = blogn_blogapi_get_param_as_scalar($params,0);
		$logid    = blogn_blogapi_get_param_as_scalar($params,1);
		$username = blogn_blogapi_get_param_as_scalar($params,2);
		$password = blogn_blogapi_get_param_as_scalar($params,3);

		blogn_blogapi_user_check( $username, $password );

		$numberOfPosts = blogn_blogapi_get_param_as_scalar($params,4);
		if ( $numberOfPosts <= 0 ) {
			throw new Exception(BLOGN_BLOGAPI_OUT_OF_NUMBER);
		}

		$user_id = blogn_blogapi_get_user_id( $username );
		$loglist = blogn_mod_db_log_load_for_list( $user_id, 0, $numberOfPosts );
		if ( !$loglist[0] ) {
			return new xmlrpcresp( new xmlrpcval( array(), 'array' ));
		}

		$array = array();
		foreach ( $loglist[1] as $key => $val ) {
			$content  = "<title>" . htmlspecialchars( $val["title"] ) . "</title>";
			$content .= $vbal["mes"] . ( $val["more"] ? ( "<br />" . $val["more"] ) : "" );
			$struct = array(
				 'dateCreated' => new xmlrpcval( blogn_blogapi_blogndate_iso8601($val['date']), 'dateTime.iso8601' )
				,'userid'      => new xmlrpcval( $key,        'string' )
				,'postid'      => new xmlrpcval( $val['id'],  'string' )
				,'content'     => new xmlrpcval( $content,    'string' )
			);
			$array[] = new xmlrpcval( $struct, 'struct' );
		}

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}

	return new xmlrpcresp( new xmlrpcval( $array, 'array' ) );
}


function blogger_getUsersBlogs($params) {
	try {
	//	$appkey   = blogn_blogapi_get_param_as_scalar($params,0);
		$username = blogn_blogapi_get_param_as_scalar($params,1);
		$password = blogn_blogapi_get_param_as_scalar($params,2);

		blogn_blogapi_user_check( $username, $password );

		$init_data = blogn_blogapi_get_init_data();
		$url       = BLOGN_HOMELINK;
		$blogid    = $init_data["id"];
		$blogname  = $init_data["sitename"];

		$array = array();
		$struct = array(
			 'url'      => new xmlrpcval( $url,      'string' )
			,'blogid'   => new xmlrpcval( $blogid,   'string' )
			,'blogName' => new xmlrpcval( $blogname, 'string' )
		);
		$array[] = new xmlrpcval( $struct, 'struct' );

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}

	return new xmlrpcresp( new xmlrpcval( $array, 'array' ) );
}


function metaWeblog_getUsersBlogs($params) {
	try {
	//	$appkey   = blogn_blogapi_get_param_as_scalar($params,0);
		$username = blogn_blogapi_get_param_as_scalar($params,1);
		$password = blogn_blogapi_get_param_as_scalar($params,2);

		blogn_blogapi_user_check( $username, $password );

		$init_data = blogn_blogapi_get_init_data();
		$url       = BLOGN_HOMELINK;
		$blogid    = $init_data["id"];
		$blogname  = $init_data["sitename"];

		$array = array();
		$struct = array(
			 'url'      => new xmlrpcval( $url,      'string' )
			,'blogid'   => new xmlrpcval( $blogid,   'string' )
			,'blogName' => new xmlrpcval( $blogname, 'string' )
		);
		$array[] = new xmlrpcval( $struct, 'struct' );

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}

	return new xmlrpcresp( new xmlrpcval( $array, 'array' ) );
}


function wp_getOptions($params) {
	try {
	//	$appkey   = blogn_blogapi_get_param_as_scalar($params,0);
		$username = blogn_blogapi_get_param_as_scalar($params,1);
		$password = blogn_blogapi_get_param_as_scalar($params,2);

		blogn_blogapi_user_check( $username, $password );

		$data = blogn_blogapi_get_param($params,3);

		$options = array();
		if ( $data -> arraysize() > 0 ) {
			for ( $i = 0; $i < $data -> arraysize(); $i++ ) {
				$option = $data -> arraymem($i);
				$options [] = $option -> scalarval();
			}
		}

		$array = array();
		foreach ( $options as $option ) {
			$struct = array(
				'option' => new xmlrpcval( $option,          'string' )
				,'value' => new xmlrpcval( $values[$option], 'string' )
			);
	 		$array[] = new xmlrpcval( $struct, 'struct' );
	 	}

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}

	return new xmlrpcresp( new xmlrpcval( $array, 'array' ) );
}


function wp_getPageList($params) {
	try {
	//	$blogid   = blogn_blogapi_get_param_as_scalar($params,0);
		$username = blogn_blogapi_get_param_as_scalar($params,1);
		$password = blogn_blogapi_get_param_as_scalar($params,2);

		blogn_blogapi_user_check( $username, $password );

		// noop

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}
	return blogn_blogapi_fault_result(BLOGN_BLOGAPI_NOT_SUPPORT_PAGE);
}


function wp_getPostStatusList($params) {
	try {
	//	$blogid   = blogn_blogapi_get_param_as_scalar($params,0);
		$username = blogn_blogapi_get_param_as_scalar($params,1);
		$password = blogn_blogapi_get_param_as_scalar($params,2);

		blogn_blogapi_user_check( $username, $password );

		$struct = array(
			 'draft'   => new xmlrpcval( '下書き',       'string' )
			,'pending' => new xmlrpcval( 'レビュー待ち', 'string' )
			,'private' => new xmlrpcval( 'プライベート', 'string' )
			,'publish' => new xmlrpcval( '投稿済み',     'string' )
		);

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}

	return new xmlrpcresp( new xmlrpcval( $struct, 'struct' ) );
}


function wp_getPageStatusList($params) {
	try {
	//	$blogid   = blogn_blogapi_get_param_as_scalar($params,0);
		$username = blogn_blogapi_get_param_as_scalar($params,1);
		$password = blogn_blogapi_get_param_as_scalar($params,2);

		blogn_blogapi_user_check( $username, $password );

		$struct = array(
			 'draft'   => new xmlrpcval( '下書き',       'string' )
			,'private' => new xmlrpcval( 'プライベート', 'string' )
			,'publish' => new xmlrpcval( '投稿済み',     'string' )
		);

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}

	return new xmlrpcresp( new xmlrpcval( $struct, 'struct' ) );
}


function wp_getUsersBlogs($params) {
	try {
		$username = blogn_blogapi_get_param_as_scalar($params,0);
		$password = blogn_blogapi_get_param_as_scalar($params,1);

		blogn_blogapi_user_check( $username, $password );

		$result   = blogn_blogapi_get_init_data();
		$url      = BLOGN_HOMELINK;
		$blogid   = $result["id"];
		$blogname = $result["sitename"];
		$xmlrpc   = BLOGN_HOMELINK . BLOGAPI_XMLRPC;

		$array  = array();
		$struct = array(
			'isAdmin'   => new xmlrpcval( TRUE,      'boolean' )
			,'url'      => new xmlrpcval( $url,      'string'  )
			,'blogid'   => new xmlrpcval( $blogid,   'string'  )
			,'blogName' => new xmlrpcval( $blogname, 'string'  )
			,'xmlrpc'   => new xmlrpcval( $xmlrpc,   'string'  )
		);
		$array[] = new xmlrpcval( $struct, 'struct' );

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}
	return new xmlrpcresp( new xmlrpcval( $array, 'array' ));
}


function mt_getCategoryList($params) {
	try {
		$blogid = blogn_blogapi_get_param_as_scalar($params,0);
		$username = blogn_blogapi_get_param_as_scalar($params,1);
		$password = blogn_blogapi_get_param_as_scalar($params,2);

		blogn_blogapi_user_check( $username, $password );

		$c_list = blogn_blogapi_get_category_list();

		$array = array();
		foreach ( $c_list as $val ) {
			$name = htmlspecialchars($val['name']);
			$id   = $val['id'];
			$struct = array(
				 'categoryId'    => new xmlrpcval( $id,   'string' )
				,'categoryName'  => new xmlrpcval( $name, 'string' )
			);
			$array[] = new xmlrpcval( $struct, 'struct' );
		}

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}

	return new xmlrpcresp( new xmlrpcval( $array, 'array' ));
}


function mt_setPostCategories($params) {
	try {
		$postid   = blogn_blogapi_get_param_as_scalar($params,0);
		$username = blogn_blogapi_get_param_as_scalar($params,1);
		$password = blogn_blogapi_get_param_as_scalar($params,2);

		blogn_blogapi_user_check( $username, $password );

		try {
			blogn_blogapi_check_permission( $username, $postid );
		} catch (Exception $e) {
			throw new Exception(BLOGN_BLOGAPI_NO_EDIT_PERMISSION);
		}

		$data = blogn_blogapi_get_param($params,3);
		$category_number = 0;
		if ( $data -> arraysize() > 0 ) {
			$struct = $data -> arraymem(0);
			$id = $struct->structmem( 'categoryId' );
			if ( $id ) {
				$category_number = $id -> scalarval();
			}

			for ( $i = 1; $i < $data -> arraysize(); $i++ ) {
				$struct = $data -> arraymem($i);
				$id = $struct->structmem( 'categoryId' );
				if ( $id ) {
					$id = $id -> scalarval();
				}

				$flag = $struct->structmem( 'isPrimary' );
				if ( $flag ) {
					if (  $flag -> scalarval() == 1 ) {
						$category_number = $id;
						break;
					}
				}
			}
		}
		$user_id = blogn_blogapi_get_user_id( $username );
		$category_id = blogn_blogapi_user_category_number_to_id( $category_number, $user_id );

		$log = blogn_blogapi_get_log( $username, $postid );

		blogn_blogapi_change_title( $postid, $category_id, $log['title'] );

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}

	return blogn_blogapi_true_result();
}


function wp_getCategories($params) {
	try {
		$username = blogn_blogapi_get_param_as_scalar($params,1);
		$password = blogn_blogapi_get_param_as_scalar($params,2);

		blogn_blogapi_user_check( $username, $password );

		$c_list = blogn_blogapi_get_category_list();

		$array = array();
		foreach ( $c_list as $val ) {
			$c_name = htmlspecialchars($val['name']);
			$c_spec = htmlspecialchars($val['spec']);
			$c_id   = htmlspecialchars($val['id']);
			$struct = array(
				 'categoryId'    => new xmlrpcval( $c_id,   'string' )	// postbot
//				 'categoryId'    => new xmlrpcval( $c_id,   'int'    )	// others
				,'parentId'      => new xmlrpcval( 0,       'int'    )
				,'description'   => new xmlrpcval( $c_name, 'string' )
				,'categoryName'  => new xmlrpcval( $c_name, 'string' )
				,'htmlUrl'       => new xmlrpcval( BLOGN_HOMELINK . "index.php?c=" . $c_spec, 'string' )
				,'rssUrl'        => new xmlrpcval( '',      'string' )
			);
			$array[] = new xmlrpcval( $struct, 'struct' );
		}

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}

	return new xmlrpcresp( new xmlrpcval( $array, 'array' ));
}


function metaWeblog_getCategories($params) {
	try {
		$username = blogn_blogapi_get_param_as_scalar($params,1);
		$password = blogn_blogapi_get_param_as_scalar($params,2);

		blogn_blogapi_user_check( $username, $password );

		$c_list = blogn_blogapi_get_category_list();

		$array = array();
		foreach ( $c_list as $val ) {
			$name = htmlspecialchars($val['name']);
			$struct = array(
				'description' => new xmlrpcval( $name, 'string' )
				,'title'      => new xmlrpcval( $name, 'string' )
			);
			$array[] = new xmlrpcval( $struct, 'struct' );
		}

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}

	return new xmlrpcresp( new xmlrpcval( $array, 'array' ));
}


function mt_getPostCategories($params) {
	try {
		$postid   = blogn_blogapi_get_param_as_scalar($params,0);
		$username = blogn_blogapi_get_param_as_scalar($params,1);
		$password = blogn_blogapi_get_param_as_scalar($params,2);

		blogn_blogapi_user_check( $username, $password );
		try {
			blogn_blogapi_check_permission( $username, $postid );
		} catch (Exception $e) {
			throw new Exception(BLOGN_BLOGAPI_NO_PERMISSION);
		}

		$log = blogn_blogapi_get_log( $username, $postid );
		$category_id = $log['category'];
		$category_num = blogn_blogapi_category_id_to_number( $category_id );
		$category_name = blogn_blogapi_category_id_to_name( $category_id );

		$array  = array();
		if ($name) {
			$struct = array(
				 'categoryName' => new xmlrpcval( $category_name, 'string'  )
				,'categoryId'   => new xmlrpcval( $category_num,  'string'  )
				,'isPrimary'    => new xmlrpcval( TRUE,           'boolean' )
			);
			$array [] = new xmlrpcval( $struct, 'struct' );
		}

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}

	return new xmlrpcresp( new xmlrpcval( $array, 'array' ));
}


function wp_uploadFile($params) {
	try {
		$username = blogn_blogapi_get_param_as_scalar($params,1);
		$password = blogn_blogapi_get_param_as_scalar($params,2);
		blogn_blogapi_user_check( $username, $password );

		$data = blogn_blogapi_get_param($params,3);
		$type = blogn_blogapi_get_struct_member( $data, 'type' );

		$overwrite = blogn_blogapi_get_struct_member( $data, 'overwrite' );
		$overwrite = ( $overwrite ) ? TRUE : FALSE;

		$name = blogn_blogapi_upload( $username, $data, $overwrite );

		$struct = array(
			 'file'  => new xmlrpcval( htmlspecialchars($name), 'string' )
			,'url'   => new xmlrpcval( htmlspecialchars(BLOGN_FILEURL.$name), 'string' )
			,'type'  => new xmlrpcval( $type, 'string' )
		);

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}

	return new xmlrpcresp( new xmlrpcval( $struct, 'struct' )  );
}


function metaWeblog_newMediaObject($params) {
	try {
		$username = blogn_blogapi_get_param_as_scalar($params,1);
		$password = blogn_blogapi_get_param_as_scalar($params,2);

		blogn_blogapi_user_check( $username, $password );

		$data = blogn_blogapi_get_param($params,3);

		$name = blogn_blogapi_upload( $username, $data, FALSE );

		$url  = htmlspecialchars( BLOGN_FILEURL . $name );

		$struct = array(
			'url'   => new xmlrpcval( htmlspecialchars(BLOGN_FILEURL.$name), 'string' )
		);

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}

	return new xmlrpcresp( new xmlrpcval( $struct, 'struct' )  );
}


function blogger_deletePost($params) {
	try {
		$postid   = blogn_blogapi_get_param_as_scalar($params,1);
		$username = blogn_blogapi_get_param_as_scalar($params,2);
		$password = blogn_blogapi_get_param_as_scalar($params,3);

		blogn_blogapi_user_check( $username, $password );

		try {
			blogn_blogapi_check_permission( $username, $postid );
		} catch (Exception $e) {
			throw new Exception(BLOGN_BLOGAPI_NO_DELETE_PERMISSION);
		}

		blogn_blogapi_delete_log($postid);

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}

	return blogn_blogapi_true_result();
}


function wp_getCommentCount($params) {
	try {
	//	$blogid   = blogn_blogapi_get_param_as_scalar($params,0);
		$username = blogn_blogapi_get_param_as_scalar($params,1);
		$password = blogn_blogapi_get_param_as_scalar($params,2);

		blogn_blogapi_user_check( $username, $password );

		$approved            = 0;
		$awaiting_moderation = 0;
		$spam                = 0;
		$total_comments      = 0;

		$postid = blogn_blogapi_get_param_as_scalar($params,3);
		if ( $postid == 0 ) {

			$user_id = blogn_blogapi_get_user_id( $username );
			$loglist = blogn_mod_db_log_load_for_list($user_id,0,0);

			if ($loglist[0]) {
				foreach ( $loglist[1] as $val ) {
					$count = blogn_mod_db_comment_count_load( $val['id'] );
					if ($count[0]) {
						$approved += $count[1];
					}
				}
			}
		} else {
			$count = blogn_mod_db_comment_count_load( $postid );
			if ($count[0]) {
				$approved = $count[1];
			}
		}
		$total_comments = $approved;

		$array = array(
			 'approved'            => new xmlrpcval( $approved,            'int' )
			,'awaiting_moderation' => new xmlrpcval( $awaiting_moderation, 'int' )
			,'spam'                => new xmlrpcval( $spam,                'int' )
			,'total_comments'      => new xmlrpcval( $total_comments,      'int' )
		);

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}

	return new xmlrpcresp( new xmlrpcval( $array, 'struct' ));
}


function wp_getComments($params) {
	try {
		$blogid   = blogn_blogapi_get_param_as_scalar($params,0);
		$username = blogn_blogapi_get_param_as_scalar($params,1);
		$password = blogn_blogapi_get_param_as_scalar($params,2);

		blogn_blogapi_user_check( $username, $password );

		$content = blogn_blogapi_get_param($params,3);
		$post_id = blogn_blogapi_get_struct_member( $content, 'post_id' );
		$status  = blogn_blogapi_get_struct_member( $content, 'status'  );
		$number  = blogn_blogapi_get_struct_member( $content, 'number'  );

		$array = array();
		if ( $post_id === "" ) {
			$comments = blogn_mod_db_comment_load_for_new( 1, 0, $number );
		} else {
			$comments = blogn_mod_db_comment_load_for_list( $post_id, 0, $number );
		}

		$user_id = blogn_blogapi_get_user_id( $username );


		$status = 'approve';
		if ($comments[0]) {
			$array = array();
			foreach ( $comments[1] as $val ) {

				try {
					blogn_blogapi_check_permission( $username, $val['entry_id'] );
				} catch (Exception $e) {
					continue;
				}

				$struct = array(
					'date_created_gmt' => new xmlrpcval( blogn_blogapi_blogndate_iso8601($val['date']), 'dateTime.iso8601' )
					,'comment_id'      => new xmlrpcval( $val['id'],       'string' ) //
					,'content'         => new xmlrpcval( $val['comment'],  'string' ) //
					,'post_id'         => new xmlrpcval( $val['entry_id'], 'string' ) //
					,'author'          => new xmlrpcval( $val['name'],     'string' ) //
					,'author_url'      => new xmlrpcval( $val['url'],      'string' ) //
					,'author_email'    => new xmlrpcval( $val['email'],    'string' ) //
					,'post_title'      => new xmlrpcval( '',               'string' ) //
					,'author_ip'       => new xmlrpcval( $val['ip'],       'string' )
					,'status'          => new xmlrpcval( $status,          'string' )
				);
				$array[] = new xmlrpcval( $struct, 'struct' );
			}
		} else {
			$array = array();
		}

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}

	return new xmlrpcresp( new xmlrpcval( $array, 'array' ) );
}


function wp_editComment($params) {
	try {
	//	$blog_id  = blogn_blogapi_get_param_as_scalar($params,0);
		$username = blogn_blogapi_get_param_as_scalar($params,1);
		$password = blogn_blogapi_get_param_as_scalar($params,2);

		blogn_blogapi_user_check( $username, $password );

		$comment_id = blogn_blogapi_get_param_as_scalar($params,3);

		$post_id = blogn_blogapi_comment_root_id( $comment_id );

		try {
			blogn_blogapi_check_permission( $username, $post_id );
		} catch (Exception $e) {
			throw new Exception(BLOGN_BLOGAPI_NO_COMMENT_EDIT_PERMISSION);
		}

		$content = blogn_blogapi_get_param($params,4);

		// noop

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}

	return blogn_blogapi_false_result();
}


function wp_deleteComment($params) {
	try {
	//	$blog_id  = blogn_blogapi_get_param_as_scalar($params,0);
		$username = blogn_blogapi_get_param_as_scalar($params,1);
		$password = blogn_blogapi_get_param_as_scalar($params,2);

		blogn_blogapi_user_check( $username, $password );

		$comment_id = blogn_blogapi_get_param_as_scalar($params,3);

		$post_id = blogn_blogapi_comment_root_id( $comment_id );

		try {
			blogn_blogapi_check_permission( $username, $post_id );
		} catch (Exception $e) {
			throw new Exception(BLOGN_BLOGAPI_NO_COMMENT_DELETE_PERMISSION);
		}

		$result = blogn_mod_db_comment_delete( $comment_id );
		if (!$result[0]) {
			return blogn_blogapi_false_result();
		}

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}

	return blogn_blogapi_true_result();
}


function wp_newComment($params) {
	try {
	//	$blog_id  = blogn_blogapi_get_param_as_scalar($params,0);
		$username = blogn_blogapi_get_param_as_scalar($params,1);
		$password = blogn_blogapi_get_param_as_scalar($params,2);
		$post_id  = blogn_blogapi_get_param_as_scalar($params,3);

		blogn_blogapi_user_check( $username, $password );

		try {
			blogn_blogapi_check_permission( $username, $post_id );
		} catch (Exception $e) {
			throw new Exception(BLOGN_BLOGAPI_NO_COMMENT_REPLY_PERMISSION);
		}

		$comment = blogn_blogapi_get_param($params,4);

		$content = blogn_blogapi_get_struct_member( $comment, 'content' );

		$secret = blogn_blogapi_get_secret( $username, $post_id );

		if ( $comment -> structmem('dateCreated') ) {
			$date = blogn_blogapi_get_struct_member( $comment, 'dateCreated' );
		} else {
			$date = date("YmdHis");
		}
	
		$date = blogn_blogapi_get_blogndate( $date );

		$author = blogn_blogapi_get_struct_member( $comment, 'author' );
		if (!$author) {
			$author = blogn_blogapi_get_user_nickname( $username );
		}

		$author_email = blogn_blogapi_get_struct_member( $comment, 'author_email' );

		$author_url = blogn_blogapi_get_struct_member( $comment, 'author_url' );
		if (!$author_url) {
			$author_url = BLOGN_HOMELINK;
		}

		$ip = $_SERVER["REMOTE_ADDR"];

		$agent = $_SERVER["HTTP_USER_AGENT"];

		$result = blogn_mod_db_comment_add( $post_id, $secret, $date, $author, $author_email, $author_url, $content, $ip, $agent );
		if ($result[0]) {
			$comment_id = $result[2];
		} else {
			return blogn_blogapi_false_result();
		}

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}

	return new xmlrpcresp( new xmlrpcval( $comment_id, 'int' ) );
}


function blogger_getUserInfo($params) {
	try {
	//  $appkey   = blogn_blogapi_get_param_as_scalar($params,0);
		$username = blogn_blogapi_get_param_as_scalar($params,1);
		$password = blogn_blogapi_get_param_as_scalar($params,2);

		blogn_blogapi_user_check( $username, $password );

		$user_list = blogn_blogapi_get_user_list();

		foreach ( $user_list as $key => $val ) {
			if ($username == $val['id']) {
				$userid    = $key;
				$nickname  = $val['name'];
				$email     = $val['user_mail_address'];
				$firstname = '';
				$lastname  = '';
				$url       = BLOGN_HOMELINK;
				break;
			}
		}

		$struct = array(
			'userid'     => new xmlrpcval( $userid,    'string' )
			,'firstname' => new xmlrpcval( $firstname, 'string' )
			,'lastname'  => new xmlrpcval( $lastname,  'string' )
			,'nickname'  => new xmlrpcval( $nickname,  'string' )
			,'email'     => new xmlrpcval( $email,     'string' )
			,'url'       => new xmlrpcval( $url,       'string' )
		);
		$array = array( new xmlrpcval( $struct, 'struct' ) );

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}

	return new xmlrpcresp( new xmlrpcval( $array, 'array' ) );
}


function mt_getRecentPostTitles ($params) {
	try {
		$username = blogn_blogapi_get_param_as_scalar($params,1);
		$password = blogn_blogapi_get_param_as_scalar($params,2);

		blogn_blogapi_user_check( $username, $password );

		$numberOfPosts = blogn_blogapi_get_param_as_scalar($params,3);
		if ($numberOfPosts<=0) {
			throw new Exception(BLOGN_BLOGAPI_OUT_OF_NUMBER);
		}

		$user_id = blogn_blogapi_get_user_id( $username );

		$loglist = blogn_mod_db_log_load_for_list( $user_id, 0, $numberOfPosts );
		if (!$loglist[0]) {
			return new xmlrpcresp( new xmlrpcval( array(), 'array' ) );
		}

		$array = array();
		foreach ( $loglist[1] as $key => $val ) {
				$struct = array(
				'dateCreated' => new xmlrpcval( blogn_blogapi_blogndate_iso8601($val['date']), 'string' )
				,'userid'     => new xmlrpcval( $key, 'string' )
				,'postid'     => new xmlrpcval( $val['id'], 'string' )
				,'title'      => new xmlrpcval( htmlspecialchars($val['title']), 'string' )
			);
			$array[] = new xmlrpcval( $struct,'struct' );
		}

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}

	return new xmlrpcresp( new xmlrpcval( $array, 'array' ) );
}


function mt_getTrackbackPings($params) {
	try {
		$postid = blogn_blogapi_get_param_as_scalar($params,0);
		$loglist = blogn_mod_db_trackback_load_for_list( $postid, 0, 0 );

		$array = array();
		if ($loglist[0]) {
			foreach ( $loglist[1] as $key => $val ) {
				$struct = array(
					'pingTitle' => new xmlrpcval( htmlspecialchars($val['title']), 'string' )
					,'pingURL'  => new xmlrpcval( $val['url'], 'string' )
					,'pingIP'   => new xmlrpcval( $val['ip'], 'string' )
				);
				$array[] = new xmlrpcval( $struct,'struct' );
			}
		}

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}

	return new xmlrpcresp( new xmlrpcval( $array, 'array' ) );
}


function mt_publishPost($params) {
	try {
		$username = blogn_blogapi_get_param_as_scalar($params,1);
		$password = blogn_blogapi_get_param_as_scalar($params,2);

		blogn_blogapi_user_check( $username, $password );

		$postid = blogn_blogapi_get_param_as_scalar($params,0);

		$log = blogn_blogapi_get_log( $username, $postid );

		// noop

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}

	return blogn_blogapi_true_result();
}


function wp_newCategory($params) {
	try {
		$username = blogn_blogapi_get_param_as_scalar($params,1);
		$password = blogn_blogapi_get_param_as_scalar($params,2);

		blogn_blogapi_user_check( $username, $password );

		$content = blogn_blogapi_get_param($params,3);
		$name = blogn_blogapi_get_struct_member( $content, 'name' );

		$category_id = blogn_blogapi_category_name_to_id( $name );

		$id = blogn_blogapi_category_id_to_number($category_id);

	} catch (Exception $e) {
		return blogn_blogapi_fault_result($e->getMessage());
	}

	return new xmlrpcresp( new xmlrpcval( $id, 'string' ) );
}


function mt_supportedMethods($params) {
	$methods = array(
		 'blogger.deletePost'
		,'blogger.getRecentPosts'
		,'blogger.getUserInfo'
		,'blogger.getUsersBlogs'
		,'blogger.newPost'
		,'metaWeblog.deletePost'
		,'metaWeblog.editPost'
		,'metaWeblog.getCategories'
		,'metaWeblog.getPost'
		,'metaWeblog.getRecentPosts'
		,'metaWeblog.getUsersBlogs'
		,'metaWeblog.newMediaObject'
		,'metaWeblog.newPost'
		,'mt.getCategoryList'
		,'mt.getPostCategories'
		,'mt.getRecentPostTitles'
//		,'mt.getTrackbackPings'
		,'mt.publishPost'
		,'mt.setPostCategories'
//		,'mt.supportedMethods'
		,'wp.deleteComment'
		,'wp.editComment'
		,'wp.getCategories'
		,'wp.getCommentCount'
		,'wp.getComments'
		,'wp.getOptions'
		,'wp.getPageList'
		,'wp.getPageStatusList'
		,'wp.getPostStatusList'
		,'wp.getUsersBlogs'
		,'wp.newCategory'
		,'wp.newComment'
		,'wp.uploadFile'
	);

	$array = array();
	foreach ( $methods as $method ) {
		$array[] = new xmlrpcval( $method, 'string' );
	}
	return new xmlrpcresp( new xmlrpcval( $array, 'array' ) );
}


//--------------------------------------------------------------------

if (strpos($blogn_blogapi_agent,'wp-android' )!==FALSE) {
	// android wordpress
	$metaWeblog_newPost_sig = array(array( 'string', 'int', 'string', 'string', 'struct', 'boolean' ));
} else if (strpos($blogn_blogapi_agent,'wp-iphone' )!==FALSE) {
	$metaWeblog_newPost_sig = array(array( 'string', 'string', 'string', 'string', 'struct' ));
} else {
	$metaWeblog_newPost_sig = array(array( 'string', 'string', 'string', 'string', 'struct', 'boolean' ));
}
$metaWeblog_newPost_doc = '';
$metaWeblog_newPost_ary = array( 'function' => 'metaWeblog_newPost',
	'signature' => $metaWeblog_newPost_sig, 'docstring' => $metaWeblog_newPost_doc );

$metaWeblog_getPost_sig = array(array( 'struct', 'string', 'string', 'string' ));
$metaWeblog_getPost_doc = '';
$metaWeblog_getPost_ary = array( 'function'=>'metaWeblog_getPost',
	'signature'=>$metaWeblog_getPost_sig,'docstring'=>$metaWeblog_getPost_doc);

$metaWeblog_getRecentPosts_sig = array(array( 'array', 'string', 'string','string','int' ));
$metaWeblog_getRecentPosts_doc = '';
$metaWeblog_getRecentPosts_ary = array( 'function'=>'metaWeblog_getRecentPosts',
	'signature'=>$metaWeblog_getRecentPosts_sig,'docstring'=>$metaWeblog_getRecentPosts_doc);

$mt_supportedMethods_sig = array(array( 'array' ));
$mt_supportedMethods_doc = '';
$mt_supportedMethods_ary = array( 'function'=>'mt_supportedMethods' );

$blogger_getUsersBlogs_sig = array(array( 'struct', 'string', 'string', 'string' ));
$blogger_getUsersBlogs_doc = '';
$blogger_getUsersBlogs_ary = array( 'function'=>'blogger_getUsersBlogs',
	'signature'=>$blogger_getUsersBlogs_sig,'docstring'=>$blogger_getUsersBlogs_doc);

$wp_getUsersBlogs_sig = array(array( 'array', 'string', 'string' ));
$wp_getUsersBlogs_doc = '';
$wp_getUsersBlogs_ary = array( 'function'=>'wp_getUsersBlogs',
	'signature'=>$wp_getUsersBlogs_sig,'docstring'=>$wp_getUsersBlogs_doc);

$metaWeblog_getUsersBlogs_sig = array(array( 'array', 'string', 'string', 'string' ));
$metaWeblog_getUsersBlogs_doc = '';
$metaWeblog_getUsersBlogs_ary = array( 'function'=>'metaWeblog_getUsersBlogs',
	'signature'=>$metaWeblog_getUsersBlogs_sig,'docstring'=>$metaWeblog_getUsersBlogs_doc);

$metaWeblog_editPost_sig = array(array( 'struct', 'string', 'string', 'string','struct','boolean' ));
$metaWeblog_editPost_doc = '';
$metaWeblog_editPost_ary = array( 'function'=>'metaWeblog_editPost',
	'signature'=>$metaWeblog_editPost_sig,'docstring'=>$metaWeblog_editPost_doc);


//if (strpos($blogn_blogapi_agent,'wp-android' )!==FALSE) {
//	$mt_getCategoryList_sig = array(array( 'struct', 'string', 'string', 'string', int ));
//} else {
	$mt_getCategoryList_sig = array(array( 'struct', 'string', 'string', 'string' ));
//}
$mt_getCategoryList_doc = '';
$mt_getCategoryList_ary = array( 'function'=>'mt_getCategoryList',
	'signature'=>$mt_getCategoryList_sig,'docstring'=>$mt_getCategoryList_doc);

$mt_setPostCategories_sig = array(array( 'int', 'string', 'string', 'string', 'array' ));
$mt_setPostCategories_doc = '';
$mt_setPostCategories_ary = array( 'function'=>'mt_setPostCategories',
	'signature'=>$mt_setPostCategories_sig,'docstring'=>$mt_setPostCategories_doc);

$mt_getPostCategories_sig = array(array( 'array', 'string', 'string', 'string' ));
$mt_getPostCategories_doc = '';
$mt_getPostCategories_ary = array( 'function'=>'mt_getPostCategories',
	'signature'=>$mt_getPostCategories_sig,'docstring'=>$mt_getPostCategories_doc);

$metaWeblog_newMediaObject_sig = array(array( 'struct', 'string', 'string', 'string', 'struct' ));
$metaWeblog_newMediaObject_doc = '';
$metaWeblog_newMediaObject_ary = array( 'function'=>'metaWeblog_newMediaObject',
	'signature'=>$metaWeblog_newMediaObject_sig,'docstring'=>$metaWeblog_newMediaObject_doc);

if (strpos($blogn_blogapi_agent,'wp-android' )!==FALSE) {
	// for android wordpress
	$blogger_deletePost_sig = array(array( 'boolean', 'string', 'string', 'string', 'string' ));
} else if (strpos($blogn_blogapi_agent,'BlogBooster' )!==FALSE) {
	// for ios blogbooster
	$blogger_deletePost_sig = array(array( 'boolean', 'string', 'string', 'string', 'string', 'int' ));
} else {
	$blogger_deletePost_sig = array(array( 'boolean', 'string', 'string', 'string', 'string', 'boolean' ));
}
$blogger_deletePost_doc = '';
$blogger_deletePost_ary = array( 'function'=>'blogger_deletePost',
	'signature'=>$blogger_deletePost_sig,'docstring'=>$blogger_deletePost_doc);

$metaWeblog_deletePost_sig = array(array( 'boolean', 'string', 'string', 'string', 'string' ));
$metaWeblog_deletePost_doc = '';
$metaWeblog_deletePost_ary = array( 'function'=>'blogger_deletePost',
	'signature'=>$metaWeblog_deletePost_sig,'docstring'=>$metaWeblog_deletePost_doc);

$blogger_getUserInfo_sig = array(array( 'array', 'string', 'string', 'string' ));
$blogger_getUserInfo_doc = '';
$blogger_getUserInfo_ary = array( 'function'=>'blogger_getUserInfo',
	'signature'=>$blogger_getUserInfo_sig,'docstring'=>$blogger_getUserInfo_doc);

$blogger_newPost_info_sig = array(array( 'string', 'string', 'string', 'string', 'string', 'string', 'string' ));
$blogger_newPost_doc = '';
$blogger_newPost_ary = array( 'function'=>'blogger_newPost',
	'signature'=>$blogger_newPost_sig,'docstring'=>$blogger_newPost_doc);

$metaWeblog_getCategories_sig = array(array( 'array', 'string', 'string', 'string' ));
$metaWeblog_getCategories_doc = '';
$metaWeblog_getCategories_ary = array( 'function'=>'metaWeblog_getCategories',
	'signature'=>$metaWeblog_getCategories_sig,'docstring'=>$metaWeblog_getCategories_doc);

$mt_publishPost_sig = array(array( 'boolean', 'string', 'string','string' ));
$mt_publishPost_doc = '';
$mt_publishPost_ary = array( 'function'=>'mt_publishPost',
	'signature'=>$mt_publishPost_sig,'docstring'=>$mt_publishPost_doc);

$mt_getRecentPostTitles_sig = array(array( 'array', 'string', 'string','string', 'int' ));
$mt_getRecentPostTitles_doc = '';
$mt_getRecentPostTitles_ary = array( 'function'=>'mt_getRecentPostTitles',
	'signature'=>$mt_getRecentPostTitles_sig,'docstring'=>$mt_getRecentPostTitles_doc);

if (strpos($blogn_blogapi_agent,'wp-android' )!==FALSE) {
	// for android wordpress
	$wp_newCategory_sig = array(array( 'string', 'int', 'string','string', 'struct' ));
} else {
	$wp_newCategory_sig = array(array( 'string', 'string', 'string','string', 'struct' ));
}
$wp_newCategory_doc = '';
$wp_newCategory_ary = array( 'function'=>'wp_newCategory',
	'signature'=>$wp_newCategory_sig,'docstring'=>$wp_newCategory_doc);

$wp_getOptions_sig = array(array( 'array', 'int', 'string', 'string', 'array' ));
$wp_getOptions_doc = '';
$wp_getOptions_ary = array( 'function'=>'wp_getOptions',
	'signature'=>$wp_getOptions_sig,'docstring'=>$wp_getOptions_doc);

$wp_getCommentCount_sig = array(array( 'array', 'int', 'string', 'string', 'int' ));
$wp_getCommentCount_doc = '';
$wp_getCommentCount_ary = array( 'function'=>'wp_getCommentCount',
	'signature'=>$wp_getCommentCount_sig,'docstring'=>$wp_getCommentCount_doc);

if (strpos($blogn_blogapi_agent,'wp-iphone' )!==FALSE) {
	$wp_getComments_sig = array(array( 'array', 'string', 'string', 'string', 'struct' ));
} else {
	$wp_getComments_sig = array(array( 'array', 'int', 'string', 'string', 'struct' ));
}
$wp_getComments_doc = '';
$wp_getComments_ary = array( 'function'=>'wp_getComments',
	'signature'=>$wp_getComments_sig,'docstring'=>$wp_getComments_doc);

if (strpos($blogn_blogapi_agent,'wp-android' )!==FALSE) {
	// android wordpress
 	$blogger_getRecentPosts_sig = array(array( 'array', 'string', 'int', 'string', 'string', 'int' ));
} else {
 	$blogger_getRecentPosts_sig = array(array( 'array', 'string', 'string', 'string', 'string', 'int' ));
}
$blogger_getRecentPosts_doc = '';
$blogger_getRecentPosts_ary = array( 'function'=>'blogger_getRecentPosts',
	'signature'=>$blogger_getRecentPosts_sig,'docstring'=>$blogger_getRecentPosts_doc);

$wp_uploadFile_sig = array(array( 'struct', 'int', 'string', 'string', 'struct' ));
$wp_uploadFile_doc = '';
$wp_uploadFile_ary = array( 'function'=>'wp_uploadFile',
	'signature'=>$wp_uploadFile_sig,'docstring'=>$wp_uploadFile_doc);

$mt_getTrackbackPings_sig = array(array( 'array', 'string' ));
$mt_getTrackbackPings_doc = '';
$mt_getTrackbackPings_ary = array( 'function'=>'mt_getTrackbackPings',
	'signature'=>$mt_getTrackbackPings_sig,'docstring'=>$mt_getTrackbackPings_doc);

if (strpos($blogn_blogapi_agent,'Apache-HttpClient/UNAVAILABLE' )!==FALSE) {
	// postbot
	$wp_getCategories_sig = array(array( 'array', 'string', 'string', 'string' ));
} else if (strpos($blogn_blogapi_agent,'wp-iphone' )!==FALSE) {
	$wp_getCategories_sig = array(array( 'array', 'string', 'string', 'string' ));
} else {
	$wp_getCategories_sig = array(array( 'array', 'int', 'string', 'string' ));
}
$wp_getCategories_doc = '';
$wp_getCategories_ary = array( 'function'=>'wp_getCategories',
	'signature'=>$wp_getCategories_sig,'docstring'=>$wp_getCategories_doc);

if (strpos($blogn_blogapi_agent,'wp-iphone' )!==FALSE) {
	$wp_getPageList_sig = array(array( 'array', 'string', 'string', 'string' ));
} else {
	$wp_getPageList_sig = array(array( 'array', 'int', 'string', 'string' ));
}
$wp_getPageList_doc = '';
$wp_getPageList_ary = array( 'function'=>'wp_getPageList',
	'signature'=>$wp_getPageList_sig,'docstring'=>$wp_getPageList_doc);

if (strpos($blogn_blogapi_agent,'wp-iphone' )!==FALSE) {
	$wp_getPostStatusList_sig = array(array( 'array', 'string', 'string', 'string' ));
} else {
	$wp_getPostStatusList_sig = array(array( 'array', 'int', 'string', 'string' ));
}
$wp_getPostStatusList_doc = '';
$wp_getPostStatusList_ary = array( 'function'=>'wp_getPostStatusList',
	'signature'=>$wp_getPostStatusList_sig,'docstring'=>$wp_getPostStatusList_doc);

if (strpos($blogn_blogapi_agent,'wp-iphone' )!==FALSE) {
	$wp_getPageStatusList_sig = array(array( 'array', 'string', 'string', 'string' ));
} else {
	$wp_getPageStatusList_sig = array(array( 'array', 'int', 'string', 'string' ));
}
$wp_getPageStatusList_doc = '';
$wp_getPageStatusList_ary = array( 'function'=>'wp_getPageStatusList',
	'signature'=>$wp_getPageStatusList_sig,'docstring'=>$wp_getPageStatusList_doc);

$wp_editComment_sig = array(array( 'boolean', 'int', 'string', 'string', 'string', 'struct' ));
$wp_editComment_doc = '';
$wp_editComment_ary = array( 'function'=>'wp_editComment',
	'signature'=>$wp_editComment_sig,'docstring'=>$wp_editComment_doc);

$wp_newComment_sig = array(array( 'int', 'int', 'string', 'string', 'int', 'struct' ));
$wp_newComment_doc = '';
$wp_newComment_ary = array( 'function'=>'wp_newComment',
	'signature'=>$wp_newComment_sig,'docstring'=>$wp_newComment_doc);

$wp_deleteComment_sig = array(array( 'boolean', 'int', 'string', 'string', 'int' ));
//$wp_deleteComment_sig = array(array( 'boolean', 'int', 'string', 'string', 'string' )); // android wordpress delete comments
$wp_deleteComment_doc = '';
$wp_deleteComment_ary = array( 'function'=>'wp_deleteComment',
	'signature'=>$wp_deleteComment_sig,'docstring'=>$wp_deleteComment_doc);


$blogn_blogapi_server = new xmlrpc_server( array(
	 'blogger.deletePost'        => $blogger_deletePost_ary
	,'blogger.getRecentPosts'    => $blogger_getRecentPosts_ary
	,'blogger.getUserInfo'       => $blogger_getUserInfo_ary
	,'blogger.getUsersBlogs'     => $blogger_getUsersBlogs_ary
	,'blogger.newPost'           => $blogger_newPost_ary
	,'metaWeblog.deletePost'     => $metaWeblog_deletePost_ary
	,'metaWeblog.editPost'       => $metaWeblog_editPost_ary
	,'metaWeblog.getCategories'  => $metaWeblog_getCategories_ary
	,'metaWeblog.getPost'        => $metaWeblog_getPost_ary
	,'metaWeblog.getRecentPosts' => $metaWeblog_getRecentPosts_ary
	,'metaWeblog.getUsersBlogs'  => $metaWeblog_getUsersBlogs_ary
	,'metaWeblog.newMediaObject' => $metaWeblog_newMediaObject_ary
	,'metaWeblog.newPost'        => $metaWeblog_newPost_ary
	,'mt.getCategoryList'        => $mt_getCategoryList_ary
	,'mt.getPostCategories'      => $mt_getPostCategories_ary
	,'mt.getRecentPostTitles'    => $mt_getRecentPostTitles_ary
//	,'mt.getTrackbackPings'      => $mt_getTrackbackPings_ary
	,'mt.publishPost'            => $mt_publishPost_ary
	,'mt.setPostCategories'      => $mt_setPostCategories_ary
//	,'mt.supportedMethods'       => $mt_supportedMethods_ary
	,'wp.deleteComment'          => $wp_deleteComment_ary
	,'wp.editComment'            => $wp_editComment_ary
	,'wp.getCategories'          => $wp_getCategories_ary
	,'wp.getCommentCount'        => $wp_getCommentCount_ary
	,'wp.getComments'            => $wp_getComments_ary
	,'wp.getOptions'             => $wp_getOptions_ary
	,'wp.getPageList'            => $wp_getPageList_ary
	,'wp.getPageStatusList'      => $wp_getPageStatusList_ary
	,'wp.getPostStatusList'      => $wp_getPostStatusList_ary
	,'wp.getUsersBlogs'          => $wp_getUsersBlogs_ary
	,'wp.newCategory'            => $wp_newCategory_ary
	,'wp.newComment'             => $wp_newComment_ary
	,'wp.uploadFile'             => $wp_uploadFile_ary
));



//--------------------------------------------------------------------
?>
